{
Copyright (C) 1999 Francois.Zbinden@djus.ch

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

If there is a bug, send a mail to winampskin-bugs@djus.ch, please.
Or use the online bug tracking system on the Homepage of WinampSkin
http://eclipse.djus.ch/winampskin.
}


unit WinampSkin;

interface

{
 !!!IMPORTANT FOR DELPHI 5!!!
 there is a bug in delphi 5. It gives you an stream read error!
 here is an fix from <david@intellex.demon.co.uk.nospam>

     In graphics.pas in TBitmap.ReadDIB there is a bug in the following line:
         RLEStream.Seek(ImageSize, soFromEnd);
     It should in fact be
         RLEStream.Seek(-ImageSize, soFromEnd);
     i.e. a negative number for the seek.
}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

type
    TSkinChecked=set of (ckRepeat,ckPlaylist,ckShuffle,ckEqualizer);
    TSkinFont=set of (sfBold, sfSelected);
    TStereoMode=set of (smMono, smStereo);
    TStatus=(ssNone,ssStop,ssPlay,ssPause);
    TMouseDownOver=(moNone,moButtons,moVolume,moBalance,moTitlebar,moPosBar,moTextScroll);
    TButtonPressed=(bpNone,bpBack,bpPlay,bpPause,bpStop,bpForward,bpEject,bpShuffle,bpRepeat,bpEqualizer,bpPlaylist);
    TTitleBarButtonPressed=(tbpNone,tbpMenu,tbpMinimize,tbpClose,tbpSticky);
    TPaintEvent=procedure(Sender:TObject) of Object;
    TVolumeChangeEvent=procedure(Sender:TObject;Volume:integer) of Object;
    TBalanceChangeEvent=procedure(Sender:TObject;Balance:integer) of Object;
    TCheckedEvent=procedure(Sender:TObject;Checked:boolean) of Object;
    TStickyEvent=procedure(Sender:TObject;Sticky:boolean) of Object;
    TPositionEvent=procedure(Sender:TObject;Position,Range:integer) of Object;


type
  TWinampSkin = class(TGraphicControl)
                      private
                      skMain,
                      skTitlebar,
                      skCButtons,
                      skVolume,
                      skNumbers,
                      skShufRep,
                      skBalance,
                      skPosBar,
                      skText,
                      skPlayPaus,
                      skMonoSter,
                      TextBmp:TBitmap;

                        FChecked:TSkinChecked;
                        FBalance:integer;
                        FTitle:string;
                        FSticky: boolean;
                        FStatus: TStatus;
                        FOnVolumeChange: TVolumeChangeEvent;
                        FOnBalanceChange: TBalanceChangeEvent;
                        FOnPlay: TNotifyEvent;
                        FOnStop: TNotifyEvent;
                        FOnPlaylist: TCheckedEvent;
                        FOnForward: TNotifyEvent;
                        FOnPause: TNotifyEvent;
                        FOnEqualizer: TCheckedEvent;
                        FOnBack: TNotifyEvent;
                        FReady: boolean;
                        FStereoMode: TStereoMode;
                        FBitrate: integer;
                        FFrequency: integer;
                        FOnEject: TNotifyEvent;
                        FOnCloseClick: TNotifyEvent;
                        FOnSticky: TStickyEvent;
                        FOnPositionChange: TPositionEvent;
                        FRightMeter: byte;
                        FLeftMeter: byte;
                        FOnSkinChanged: TNotifyEvent;
                        FSystemTitle:string;
                        FActive: boolean;
                        FVolume: integer;
                        FPositionBar: integer;
                        FProgress: string;
                        FOnMenuClick: TNotifyEvent;
                        FAutoCursor: boolean;
                        FPosBarMove: boolean;

                        VolumeFocus,
                        BalanceFocus,
                        PositionBarFocus,
                        BalanceFromVolume:boolean;


                        MouseDownOver:TMouseDownOver;
                        ButtonPressed:TButtonPressed;
                        TitleBarButtonPressed:TTitleBarButtonPressed;

                        TitleLength,
                        MouseDownX,
                        MouseDownTitlePos,
                        MouseDownVolume,
                        MouseDownBalance,
                        MouseDownPosBar:integer;
                        FTextScrollTimer: Cardinal;
                        VisColor:array[0..24] of TColor;

                        procedure TestButtons(x,y:integer);
                        procedure TestVolume(x,y:integer);
                        procedure TestTitleBarButtons(x,y:integer);
                        procedure TestBalance(x,y:integer);
                        procedure TestStickyButtons(x,y:integer);
                        procedure TestPosBar(x,y:integer);
                        procedure TestTitle(x,y:integer);
                        function CalcVol(x:integer):byte;
                        function CalcBal(x:integer):byte;
                        procedure GetCharPos(c:char;var x,y:integer;mode: TSkinFont);
                        function TextOut(Can:TCanvas;s:string;x,y:integer; font: TSkinFont):integer;
                        procedure PaintDigit(d:byte;dest:trect);
                        procedure PaintMain;                              //  paint background, title bar
                        procedure PaintButtons;                           //  paint buttons
                        procedure PaintVolume;                            // paint volume bar and
                        procedure PaintBalance;                           //       balance
                        procedure PaintCheckboxes;                        // paint checkboxes (shuffle, repeat and pl, eq)
                        procedure PaintTitleBarButtons;                   // paint small title bar buttons position
                        procedure PaintProgress;                          // paint progess
                        procedure PaintPosBar;
                        procedure PaintTitleBar;
                        procedure PaintStatus;
                        procedure PaintBitrate;
                        procedure PaintFrequency;
                        procedure PaintStereoMode;
                        procedure PaintMeter;
                        procedure PaintTitle;

                        procedure SetActive(const Value: boolean);
                        procedure SetVolume(const Value: integer);
                        procedure SetPositionBar(const Value: integer);
                        procedure SetProgress(const Value: string);
                        procedure SetSystemTitle(const Value: string);
                        procedure SetTitle(const Value: string);
                        procedure SetSticky(const Value: boolean);
                        procedure SetChecked(value:TSkinChecked);
                        procedure SetBalance(Value:integer);
                        procedure SetStatus(const Value: TStatus);
                        procedure SetReady(const Value: boolean);
                        procedure SetBitrate(const Value: integer);
                        procedure SetFrequency(const Value: integer);
                        procedure SetStereoMode(const Value: TStereoMode);
                        procedure SetLeftMeter(const Value: byte);
                        procedure SetRightMeter(const Value: byte);
                        procedure SetTextScrollTimer(const Value: Cardinal);

                  protected
                        ScrollTimer:TTimer;
                        procedure MouseMove(Shift: TShiftState;x,y:integer);override;
                        procedure MouseDown(Button: TMouseButton;Shift: TShiftState;x,y:integer);override;
                        procedure MouseUp(Button: TMouseButton;Shift: TShiftState;x,y:integer);override;
                        procedure TextTimer(Sender: TObject);
                        property SystemTitle: string read FSystemTitle write SetSystemTitle;

                  public
                        isMouseDown:boolean;
                        ProgressMin,
                        ProgressSec:byte;
                        PosOffset,
                        PosRange:integer;
                        TextScrollPos:integer;
                        constructor Create(AOwner: TComponent);  override;
                        destructor Destroy;override;
                        function LoadFromDirectory(Directory:string):integer; // load skin from normal winamp skin in a directory.
                        function LoadFromResource:integer;                   // load default skin from resource file
                        procedure Paint; override;                           // paint everything
                        property TextScrollTimer:Cardinal read FTextScrollTimer write SetTextScrollTimer default 200;

                   published

                       property OnVolumeChange: TVolumeChangeEvent read FOnVolumeChange write FOnVolumeChange;
                       property OnBalanceChange: TBalanceChangeEvent read FOnBalanceChange write FOnBalanceChange;
                       property OnPlayClick: TNotifyEvent read FOnPlay write FOnPlay;
                       property OnStopClick: TNotifyEvent read FOnStop write FOnStop;
                       property OnPauseClick: TNotifyEvent read FonPause write FOnPause;
                       property OnForwardClick: TNotifyEvent read FOnForward write FOnForward;
                       property OnBackClick: TNotifyEvent read FOnBack write FOnBack;
                       property OnEjectClick: TNotifyEvent read FOnEject write FOnEject;
                       property OnPlaylistClick: TCHeckedEvent read FOnPlaylist write FOnPlaylist;
                       property OnEqualizerClick: TCheckedEvent read FOnEqualizer write FOnEqualizer;
                       property OnCloseClick: TNotifyEvent read FOnCloseClick write FOnCloseClick;
                       property OnSticky: TStickyEvent read FOnSticky write FOnSticky;
                       property OnPositionChange: TPositionEvent read FOnPositionChange write FOnPositionChange;
                       property OnSkinChanged: TNotifyEvent read FOnSkinChanged write FOnSkinChanged;
                       property OnMenuClick:  TNotifyEvent read FOnMenuClick write FOnMenuClick;
                       property Checked: TSkinChecked read FChecked write SetChecked;
                       property Volume:integer read FVolume write SetVolume default 80;
                       property Balance: integer read FBalance write SetBalance default 50;
                       property Title: string read FTitle write SetTitle;
                       property Sticky: boolean read FSticky write SetSticky;
                       property Status:TStatus read FStatus write SetStatus;
                       property Ready:boolean read FReady write SetReady;
                       property Bitrate:integer read FBitrate write SetBitrate;
                       property Frequency:integer read FFrequency write SetFrequency;
                       property StereoMode:TStereoMode read FStereoMode write SetStereoMode;
                       property LeftMeter:byte read FLeftMeter write SetLeftMeter;
                       property RightMeter:byte read FRightMeter write SetRightMeter;
                       property Active:boolean read FActive write SetActive;
                       property PositionBar:integer read FPositionBar write SetPositionBar;
                       property Progress:string read FProgress write SetProgress;
                       property AutoCursor:boolean read FAutoCursor write FAutoCursor default true;
                       property Height default 116;
                       property Width default 275;
                       property PosBarMove:boolean read FPosBarMove write FPosBarMove default true;
                       end;

 const

     skcNormal=5;           // ids for the skin bitmaps
     skcSONGNAME=6;
     skcWSWINBUT=7;
     skcWSMIN=8;
     skcWSPOSBAR=9;
     skcWSCLOSE=10;
     skcWSNORMAL=11;
     skcMIN=12;
     skcEQCLOSE=13;
     skcEQSLID=14;
     skcEQTITLE=15;
     skcEQNORMAL=16;
     skcPWSSIZE=17;
     skcPWSNORM=18;
     skcPWINBUT=19;
     skcPTBAR=20;
     skcPCLOSE=21;
     skcCLOSE=22;
     skcPVSCROLL=23;
     skcVOLBAL=24;
     skcPSIZE=25;
     skcPOSBAR=26;

     procedure Register;


 const
 BmpStartPos = SizeOf(TBitmapFileHeader);
 VERSION = '0.1b';

 START_MESSAGE = ' ***  Winamp Skin Component '+VERSION+' ***  by Francois Zbinden  ***  http://eclipse.djus.ch  ';


 const VisColorArr : array[0..23] of PChar = (
        '0,0,0', // color 0 = black
        '24,33,41', // color 1 = grey for dots
        '239,49,16', // color 2 = top of spec
        '206,41,16', // 3
        '214,90,0', // 4
        '214,102,0', // 5
        '214,115,0', // 6
        '198,123,8', // 7
        '222,165,24', // 8
        '214,181,33', // 9
        '189,222,41', // 10
        '148,222,33', // 11
        '41,206,16', // 12
        '50,190,16', // 13
        '57,181,16', // 14
        '49,156,8 ', // 15
        '41,148,0 ', // 16
        '24,132,8  ', // 17 = bottom of spec
        '255,255,255', // 18 = osc 1
        '214,214,222', // 19 = osc 2 (slightly dimmer)
        '181,189,189', // 20 = osc 3
        '160,170,175 ', // 21 = osc 4
        '148,156,165', // 22 = osc 4
        '150,150,150'); // 23 = analyzer peak dots

 var
  HWinampSkin: TWinampSkin;

implementation
{$R _winampskin.dcr}


procedure Register;
begin
  RegisterComponents('Freeware', [TWinampSkin]);
end;

function RGBToColor(s:string):TColor;
var ColorString:string;
    Red,Green,Blue:string;
begin
     if (Length(s)>11) or (Length(s)<5) then
     begin
        RGBToColor:=StringToColor('$00FF0000');
        exit;
     end;
     Red:=IntToHex(StrToInt(copy(s,0,pos(',',s)-1)),2);
     s:=copy(s,pos(',',s)+1,length(s)-1);
     Green:=IntToHex(StrToInt(copy(s,0,pos(',',s)-1)),2);
     s:=copy(s,pos(',',s)+1,length(s)-1);
     if pos(',',s)>0 then
        s:=copy(s,0,pos(',',s)-1);
     Blue:=IntToHex(StrToInt(copy(s,0,length(s))),2);
     ColorString:='$00'+Blue+Green+Red;
     RGBToColor:=strtoint(ColorString); //StringToColor(ColorString);
end;

Function StrToColor(line:string):TColor;
begin
       if Pos(Chr(9),line)>0 then
          line:=copy(line,0,pos(chr(9),line)-1)
      else if pos(' ',line)>0 then
          line:=copy(line,0,pos(' ',line)-1)
      else if pos('/',line)>0 then
          line:=copy(line,0,pos('/',line)-1);

     StrToColor:=RGBToColor(line);
End;

function InRect(x,y,left,top,right,down:integer):boolean;
begin
     if (x>left) and (x<right) and (y>top) and (y<down) then
            InRect:=true
               else
            InRect:=false;
end;

function TWinampSkin.CalcVol(x: integer): byte;
begin
     if x <= 104  then CalcVol:=0
       else
       CalcVol:=round(10/(7/(x-104)));
     if x> 171 then CalcVol:=100;
end;

function TWinampSkin.CalcBal(x: integer): byte;
begin
    if x <= 177 then CalcBal:=0
      else
     CalcBal:=round(100/(38/(x-177)));
     if x > 215 then CalcBal:=100;
end;

constructor TWinampSkin.Create(AOwner: TComponent);
begin
     inherited Create(AOwner);
     Left:=0;
     Top:=0;
     Width:=275;
     Height:=116;
     fsticky:=false;
     FVolume:=80;
     FBalance:=50;
     FReady:=true;
     FFrequency:=-1;
     FBitrate:=-1;
     FStereoMode:=[];
     FTitle:=START_MESSAGE;
     FTextScrollTimer:=200;
     ProgressMin:=255;
     ProgressSec:=255;
     skMain:=TBitmap.Create;
     skTitleBar:=TBitmap.Create;
     skCButtons:=TBitmap.Create;
     skVolume:=TBitmap.Create;
     skNumbers:=TBitmap.Create;
     skShufRep:=TBitmap.Create;
     skBalance:=TBitmap.Create;
     skPosBar:=TBitmap.Create;
     skText:=TBitmap.Create;
     skPlayPaus:=TBitmap.Create;
     skMonoSter:=TBitmap.Create;
     TextBmp:=TBitmap.Create;
     TextBmp.Width:=1048;
     TextBmp.Height:=10;
     Cursor:=skcNormal;
     ScrollTimer:=TTimer.Create(self);
     ScrollTimer.Interval:=TextScrollTimer;
     ScrollTimer.Enabled:=true;  // set to false if you don't need title scrolling.
     ScrollTimer.OnTimer:=TextTimer;
     isMouseDown:=false;
     ButtonPressed:=bpNone;
     TitleBarButtonPressed:=tbpNone;
     FChecked:=[];
     LoadFromResource;
end;


destructor TWinampSkin.Destroy;
begin
     skMain.free;
     skTitleBar.free;
     skCButtons.free;
     skVolume.free;
     skNumbers.free;
     skShufRep.free;
     skBalance.free;
     skPosBar.free;
     skText.free;
     skPlayPaus.free;
     skMonoSter.free;
     TextBmp.free;
     ScrollTimer.free;
     inherited Destroy;
end;

function TWinampSkin.LoadFromDirectory(Directory: string): integer;
var ClrFile:TextFile;
    Line:string;
    LineCount:byte;
   function LoadCursorFile(filename:string):TCursor;
   var fn,rn:array[0..1024] of char;
   begin
     strpcopy(fn,filename);
     strpcopy(rn,copy(ExtractFileName(filename),0,pos('.',filename)));
     if FileExists(filename) then
          LoadCursorFile:=LoadCursorFromFile(fn)
      else
          LoadCursorFile:=LoadCursor(HInstance,rn);
   end;

begin
  BalanceFromVolume:=false;
  LoadFromResource;
  LoadFromDirectory:=0;
   try
   if FileExists(Directory+'\main.bmp') then
     skMain.LoadFromFile(Directory+'\main.bmp');
     if FileExists(Directory+'\titlebar.bmp') then
         skTitlebar.LoadFromFile(Directory+'\titlebar.bmp');
     if FileExists(Directory+'\cbuttons.bmp') then
          skCButtons.LoadFromFile(Directory+'\cbuttons.bmp');
     if FileExists(Directory+'\volume.bmp') then
          skVolume.LoadFromFile(Directory+'\volume.bmp');
     if FileExists(Directory+'\numbers.bmp') then
          skNumbers.LoadFromFile(Directory+'\numbers.bmp');
     if FileExists(Directory+'\shufrep.bmp') then
          skShufRep.LoadFromFile(Directory+'\shufrep.bmp');
     if FileExists(Directory+'\balance.bmp') then                  // there are skins don't have balance bitmal.
         skBalance.LoadFromFile(Directory+'\balance.bmp')          // it takes the volume bitmap and resize it to the size of balance
       else
         BalanceFromVolume:=true;
     if FileExists(Directory+'\posbar.bmp') then
          skPosBar.LoadFromFile(Directory+'\posbar.bmp');
     if FileExists(Directory+'\text.bmp') then
          skText.LoadFromFile(Directory+'\text.bmp');
     if FileExists(Directory+'\playpaus.bmp') then
          skPlayPaus.LoadFromFile(Directory+'\playpaus.bmp');
     if FileExists(Directory+'\monoster.bmp') then
          skMonoster.LoadFromFile(Directory+'\monoster.bmp');
     if FileExists(Directory+'\normal.cur') then
          Screen.Cursors[skcNormal]:=LoadCursorFile(Directory+'\normal.cur');         // we newer use all this cusors.. you can delete a few in the
     if FileExists(Directory+'\songname.cur') then
          Screen.Cursors[skcSongname]:=LoadCursorFile(Directory+'\songname.cur');
     if FileExists(Directory+'\wswinbut.cur') then
          Screen.Cursors[skcwswinbut]:=LoadCursorFile(Directory+'\wswinbut.cur');
     if FileExists(Directory+'\wsmin.cur') then
          Screen.Cursors[skcwsmin]:=LoadCursorFile(Directory+'\wsmin.cur');
     if FileExists(Directory+'\wsposbar.cur') then
          Screen.Cursors[skcWsPosBar]:=LoadCursorFile(Directory+'\wsposbar.cur');
     if FileExists(Directory+'\wsclose.cur') then
          Screen.Cursors[skcWsClose]:=LoadCursorFile(Directory+'\wsclose.cur');
     if FileExists(Directory+'\wsnormal.cur') then
          Screen.Cursors[skcWsPosBar]:=LoadCursorFile(Directory+'\wsnormal.cur');
     if FileExists(Directory+'\min.cur') then
          Screen.Cursors[skcMin]:=LoadCursorFile(Directory+'\min.cur');
     if FileExists(Directory+'\eqclose.cur') then
          Screen.Cursors[skcEqClose]:=LoadCursorFile(Directory+'\eqclose.cur');
     if FileExists(Directory+'\eqslid.cur') then
          Screen.Cursors[skcEqSlid]:=LoadCursorFile(Directory+'\eqslid.cur');
     if FileExists(Directory+'\eqtitle.cur') then
          Screen.Cursors[skcEqTitle]:=LoadCursorFile(Directory+'\eqtitle.cur');
     if FileExists(Directory+'\eqnormal.cur') then
          Screen.Cursors[skcMin]:=LoadCursorFile(Directory+'\eqnormal.cur');
     if FileExists(Directory+'\pwssize.cur') then
          Screen.Cursors[skcPwsSize]:=LoadCursorFile(Directory+'\pwssize.cur');
     if FileExists(Directory+'\pwsnorm.cur') then
          Screen.Cursors[skcMin]:=LoadCursorFile(Directory+'\pwsnorm.cur');
     if FileExists(Directory+'\pwinbut.cur') then
          Screen.Cursors[skcPWinBut]:=LoadCursorFile(Directory+'\pwinbut.cur');
     if FileExists(Directory+'\ptbar.cur') then
          Screen.Cursors[skcPTBar]:=LoadCursorFile(Directory+'\ptbar.cur');
     if FileExists(Directory+'\pclose.cur') then
          Screen.Cursors[skcClose]:=LoadCursorFile(Directory+'\pclose.cur');
     if FileExists(Directory+'\pvscroll.cur') then
          Screen.Cursors[skcpvscroll]:=LoadCursorFile(Directory+'\pvscroll.cur');
     if FileExists(Directory+'\volbal.cur') then
          Screen.Cursors[skcvolbal]:=LoadCursorFile(Directory+'\volbar.cur');
     if FileExists(Directory+'\psize.cur') then
          Screen.Cursors[skcpsize]:=LoadCursorFile(Directory+'\psize.cur');
     if FileExists(Directory+'\close.cur') then
          Screen.Cursors[skcpsize]:=LoadCursorFile(Directory+'\close.cur');
     if FileExists(Directory+'\posbar.cur') then
          Screen.Cursors[skcposbar]:=LoadCursorFile(Directory+'\posbar.cur');

    if FileExists(Directory+'\viscolor.txt') then
    begin
        AssignFile(ClrFile,Directory+'\viscolor.txt');
        Reset(ClrFile);
        LineCount:=0;
        while not Eof(ClrFile) do
        begin
             Readln(ClrFile,Line);
             if Length(Line)<>0 then
                begin
                VisColor[LineCount]:=StringToColor(line);
                inc(LineCount);
                if LineCount>24 then
                   break;
                end;
        end;
    end else
    begin
        for LineCount:=0 to 24 do
                VisColor[LineCount]:=StringToColor(VisColorArr[LineCount]);
        CloseFile(ClrFile);
    end;
    Paint;
    if Assigned(FOnSkinChanged) then
       FOnSkinChanged(self);
   except
     LoadFromDirectory:=-1;
   end;
end;

function TWinampSkin.LoadFromResource: integer;
var
   LineCount:byte;
begin
     skMain.LoadFromResourceName(HInstance,'MAIN');
     skTitlebar.LoadFromResourceName(HInstance,'TITLEBAR');
     skCButtons.LoadFromResourceName(HInstance,'CBUTTONS');
     skVolume.LoadFromResourceName(HInstance,'VOLUME');
     skNumbers.LoadFromResourceName(HInstance,'NUMBERS');
     skShufRep.LoadFromResourceName(HInstance,'SHUFREP');
     skBalance.LoadFromResourceName(HInstance,'BALANCE');
     skPosBar.LoadFromResourceName(HInstance,'POSBAR');
     skText.LoadFromResourceName(HInstance,'TEXT');
     skPlayPaus.LoadFromResourceName(HInstance,'PLAYPAUS');
     skMonoSter.LoadFromResourceName(HInstance,'MONOSTER');
     for LineCount:=0 to 23 do
                VisColor[LineCount]:=StrToColor(VisColorArr[LineCount]);
     Screen.Cursors[skcSongname]:=LoadCursor(HInstance, 'SONGNAME');
     Screen.Cursors[skcWsWinBut]:=LoadCursor(HInstance, 'WSWINBUT');
     Screen.Cursors[skcWSMin]:=LoadCursor(HInstance, 'WSMIN');
     Screen.Cursors[skcWSPosBar]:=LoadCursor(HInstance, 'WSPOSBAR');
     Screen.Cursors[skcWSClose]:=LoadCursor(HInstance, 'WSCLOSE');
     Screen.Cursors[skcWSNormal]:=LoadCursor(HInstance, 'WSNORMAL');
     Screen.Cursors[skcMin]:=LoadCursor(HInstance, 'MIN');
     Screen.Cursors[skcEQClose]:=LoadCursor(HInstance, 'EQCLOSE');
     Screen.Cursors[skcEQSlid]:=LoadCursor(HInstance, 'EQSLID');
     Screen.Cursors[skcEQTITLE]:=LoadCursor(HInstance, 'EQTITLE');
     Screen.Cursors[skcEQNORMAL]:=LoadCursor(HInstance, 'EQNORMAL');
     Screen.Cursors[skcPWSSIZE]:=LoadCursor(HInstance, 'PWSSIZE');
     Screen.Cursors[skcPwsNorm]:=LoadCursor(HInstance, 'PWSNORM');
     Screen.Cursors[skcPWinBut]:=LoadCursor(HInstance, 'PWINBUT');
     Screen.Cursors[skcPTBar]:=LoadCursor(HInstance, 'PTBAR');
     Screen.Cursors[skcPClose]:=LoadCursor(HInstance, 'PCLOSE');
     Screen.Cursors[skcNormal]:=LoadCursor(HInstance, 'NORMAL');
     Screen.Cursors[skcPvScroll]:=LoadCursor(HInstance, 'PVSCROLL');
     Screen.Cursors[skcVolBal]:=LoadCursor(HInstance, 'VOLBAL');
     Screen.Cursors[skcPSize]:=LoadCursor(HInstance, 'PSIZE');
     Screen.Cursors[skcClose]:=LoadCursor(HInstance, 'CLOSE');
     Screen.Cursors[skcPosbar]:=LoadCursor(HInstance, 'POSBAR');
     LoadFromResource:=0;
end;


procedure TWinampSkin.MouseDown(Button: TMouseButton; Shift: TShiftState;x, y: integer);
begin
     MouseDownX:=x;
     MouseDownOver:=moNone;
     if not sticky then
       begin
         TestButtons(x,y);
         TestVolume(x,y);
         TestBalance(x,y);
         TestPosBar(x,y);
         TestTitle(x,y);
      end else
         TestStickyButtons(x,y);
     TestTitleBarButtons(x,y);
     isMouseDown:=true;
     inherited MouseDown(button,shift,x,y);
end;


procedure TWinampSkin.MouseMove(Shift: TShiftState;x, y: integer);
var
   titelbastel:string;
begin
     if isMouseDown then
             begin
        case MouseDownOver of
             moButtons: TestButtons(x,y);
             moVolume: begin
                        if x < 105  then Volume:=0
                            else if x> 171 then Volume:=100
                               else if x<>MouseDownx then
                                    volume:=round(MouseDownVolume+((x-MouseDownX)/54*100));
                         if volume=100 then
                            volume:=100;
                          if Assigned(FOnVolumeChange) then
                            FOnVolumeChange(self,volume);
                         SystemTitle:='VOLUME: '+inttostr(volume)+'%';
                          end;
             moBalance: begin
                        if x < 177 then Balance:=0
                           else if x>215 then Balance:=100
                               else if x<>MouseDownx then
                                  Balance:=round((MouseDownBalance+((x-MouseDownX)/28*100)));
       
                           if balance<46 then
                              titelbastel:=inttostr(abs(calcbal(x)*2-100))+'% LEFT'
                            else if balance>54 then
                               titelbastel:=inttostr(calcbal(x)*2-100)+'% RIGHT'
                            else
                               begin
                               balance:=50;
                               titelbastel:='CENTER';
                               end;
                         SystemTitle:='BALANCE: '+titelbastel;
                         if Assigned (FOnBalanceChange) then
                            FOnBalanceChange(self,balance);
                         end;
             moTitleBar: TestTitleBarButtons(x,y);
             moPosBar:  begin
                        if (x<18) then
                           PositionBar:=1
                            else
                           PositionBar:=MouseDownPosBar+round((x-MouseDownX)/215*255);
//                        SystemTitle:='Seek: '+IntToStr(PositionBar);
                        end;
             moTextScroll: begin
                               TextScrollPos:=MouseDownTitlePos-round(x-MouseDownX);
                               PaintTitle;
                            end;
             end;
        end
        else
        if AutoCursor=true then
         begin
          if InRect(x,y,264,3,273,12) then
             Screen.Cursor:=skcClose
             else if InRect(x,y,110,25,265,35) then
               Screen.Cursor:=skcSongName
            else if InRect(x,y,244,3,253,12) then
               Screen.Cursor:=skcMin
            else if InRect(x,y,17,73,264,81) then
               Screen.Cursor:=skcPosBar
             else
                  Screen.Cursor:=skcNormal;                    //244,3,253,12

        end;

        inherited MouseMove(Shift,x,y);
end;

procedure TWinampSkin.MouseUp(Button: TMouseButton; Shift: TShiftState;x, y: integer);
begin
     isMouseDown:=false;

     case MouseDownOver of
             moButtons:begin
                       case ButtonPressed of
                             bpPlay: if Assigned (FOnPlay) then
                                       FOnPlay(self);
                             bpStop: if Assigned (FOnStop) then
                                        FOnStop(self);
                             bpBack: if Assigned (FOnBack) then
                                        FOnBack(self);
                             bpForward: if Assigned (FOnForward) then
                                        FOnForward(self);
                             bpPause: if Assigned (FOnPause) then
                                        FOnPause(self);
                             bpShuffle: if (ckShuffle in Checked) then
                                           FChecked:=FChecked-[ckShuffle]
                                          else
                                           FChecked:=FChecked+[ckShuffle];
                             bpRepeat: if (ckRepeat in Checked) then
                                           FChecked:=FChecked-[ckRepeat]
                                          else
                                           FChecked:=FChecked+[ckRepeat];
                             bpPlaylist: if (ckPlaylist in FChecked) then
                                         begin
                                           FChecked:=FChecked-[ckPlaylist];
                                           if Assigned(FOnPlaylist) then
                                              FOnPlaylist(self,false);
                                         end else begin
                                           FChecked:=FChecked+[ckPlaylist];
                                           if Assigned(FOnPlaylist) then
                                              FOnPlaylist(self,true);
                                           end;
                             bpEqualizer: if (ckEqualizer in FChecked) then
                                           begin
                                           FChecked:=FChecked-[ckEqualizer];
                                           if Assigned(FOnEqualizer) then
                                              FOnEqualizer(self,false);
                                          end else
                                          begin
                                           FChecked:=FChecked+[ckEqualizer];
                                           if Assigned(FOnEqualizer) then
                                              FOnEqualizer(self,true);
                                          end;

                                   end;
                             ButtonPressed:=bpNone;
                             PaintCheckboxes;
                             PaintButtons;
                         end;
             moVolume: begin
                            VolumeFocus:=false;
                            SystemTitle:='';                         // Display song title again
                            PaintVolume;
                         end;
             moBalance: begin
                             BalanceFocus:=false;
                             SystemTitle:='';
                             PaintBalance;
                          end;
             moTitleBar: begin
                         case TitleBarButtonPressed of
                                   tbpMenu: if Assigned(PopupMenu) then
                                         PopupMenu.Popup(parent.Left+x,parent.top+y)
                                      else
                                          if Assigned (FOnMenuClick) then
                                            FOnMenuClick(self);
                                   tbpMinimize: Application.Minimize;
                                   tbpClose: if Assigned (FOnCloseClick) then FOnCloseClick(self);
                                   tbpSticky: sticky:=not sticky;
                              end;
                          Active:=true
                         end;
             moPosBar: begin
                      PositionBarFocus:=false;
                      PaintPosBar;
                       end;
             moTextScroll: ScrollTimer.Enabled:=true;
     end;

     MouseDownOver:=moNone;
     inherited mouseup(button,shift,x,y);
end;


procedure TWinampSkin.Paint;
begin
     FActive:=Application.Active;
     PaintMain;
     PaintButtons;
     PaintVolume;
     PaintBalance;
     PaintProgress;
     PaintCheckboxes;
     PaintTitle;
     PaintPosBar;
     PaintStatus;
     PaintFrequency;
     PaintBitrate;
     PaintStereoMode;
     PaintMeter;
     inherited paint;
end;

procedure TWinampSkin.PaintBalance;
var src,dest:TRect;
   stufe:byte;
   balan:integer;
begin
     if Balance<0 then balan:=0 else
             balan:=Balance;
     if balan>100 then balan:=100;
     stufe:=round(abs((balan-50)*54/50/2));

     dest:=rect(177,57,217,71);

     if BalanceFromVolume then
        begin
          src:=rect(9,stufe*15,68,((stufe+1)*15)-1);
          Canvas.CopyRect(dest,skVolume.Canvas,src);
        end else
        begin
          src:=rect(9,stufe*15,47,((stufe+1)*15)-1);
          Canvas.CopyRect(dest,skBalance.Canvas,src);
        end;
     if balan=0 then balan:=1;
     if BalanceFocus then
       src:=rect(0,422,14,433)
     else
       src:=rect(15,422,29,433);
      dest:=rect(177+trunc(28/(100/balan)),59,191+trunc(28/(100/balan)),70);

     if BalanceFromVolume then
        Canvas.CopyRect(dest,skVolume.Canvas,src)
     else
        Canvas.CopyRect(dest,skBalance.Canvas,src);
end;

procedure TWinampSkin.PaintButtons;
var src,dest:TRect;
    i,bp,rip:byte;
begin
      // paint play, stop, pause, .. buttons
     for i:=0 to 4 do
     begin
         if i=4 then
             rip:=1 else rip:=0;
             case ButtonPressed of
                  bpBack: bp:=0;
                  bpPlay: bp:=1;
                  bpPause: bp:=2;
                  bpStop: bp:=3;
                  bpForward: bp:=4;
             else
                  bp := 99;
             end;
         if i = bp then
             src:=rect(i*23,18,(i+1)*23-rip,35)
           else
             src:=rect(i*23,0,(i+1)*23-rip,17);
     dest:=rect(i*23+19,88,(i+1)*23+19-rip,105);
     Canvas.CopyRect(dest,skCButtons.Canvas,src);

     if ButtonPressed=bpEject then
        src:=rect(114,16,135,31)
      else
        src:=rect(114,0,135,15);
     dest:=rect(136,89,158,105);
     Canvas.CopyRect(dest,skCButtons.Canvas,src);
     end;
end;

procedure TWinampSkin.PaintCheckboxes;
var src,dest:TRect;
begin
     if (ckShuffle in Checked) then
       begin
         if ButtonPressed=bpShuffle then
             src:=rect(28,45,75,60)
         else
             src:=rect(28,30,75,45)
     end else
        begin
         if ButtonPressed=bpShuffle then
             src:=rect(28,15,75,30)
         else
             src:=rect(28,0,75,15);
        end;
         dest:=rect(164,89,212,104);
       Canvas.CopyRect(dest,skShufRep.Canvas,src);

//// repeat  button
    if (ckRepeat in Checked) then
       begin
         if ButtonPressed=bpRepeat then
             src:=rect(0,45,27,60)
         else
             src:=rect(0,30,27,45)
     end else
        begin
         if ButtonPressed=bpRepeat then
             src:=rect(0,15,27,30)
         else
             src:=rect(0,0,27,15);
        end;
         dest:=rect(210,89,237,104);
       Canvas.CopyRect(dest,skShufRep.Canvas,src);

/// playlist button
    if (ckPlaylist in Checked) then
       begin
         if ButtonPressed=bpPlaylist then
             src:=rect(69,73,92,84)
         else
             src:=rect(23,73,46,84)
     end else
        begin
         if ButtonPressed=bpPlaylist then
             src:=rect(69,61,92,72)
         else
             src:=rect(23,61,46,72);
        end;
         dest:=rect(242,58,265,69);
       Canvas.CopyRect(dest,skShufRep.Canvas,src);

/// equalizer  button
    if (ckEqualizer in Checked) then
       begin
         if ButtonPressed=bpEqualizer then
             src:=rect(47,73,70,84)
         else
             src:=rect(0,73,23,84)
     end else
        begin
         if ButtonPressed=bpEqualizer then
             src:=rect(47,61,70,72)
         else
             src:=rect(0,61,23,72);
        end;
            dest:=rect(219,58,242,69);
       Canvas.CopyRect(dest,skShufRep.Canvas,src);
end;

procedure TWinampSkin.PaintDigit(d:byte;dest:trect);
var src:TRect;
begin
     if d>9 then d:=10;
     src:=rect(d*9,0,(d+1)*9,13);
     Canvas.CopyRect(dest,skNumbers.Canvas,src);
end;

procedure TWinampSkin.PaintMain;
begin
    Canvas.Draw(0,0,skMain);
    PaintTitleBar;
end;

procedure TWinampSkin.PaintTitleBar;
var src,dest:TRect;
begin
    if not sticky then
     begin
        if Active then
          src:=rect(27,0,301,14)
         else
          src:=rect(27,15,301,29);

     end else
     begin
        Canvas.Draw(0,0,skMain);
        if Active then
          src:=rect(27,29,301,42)
         else
          src:=rect(27,42,301,56);
     end;
   dest:=rect(0,0,274,14);
   Canvas.CopyRect(dest,skTitlebar.Canvas,src);
end;


procedure TWinampSkin.PaintProgress;            // paint the 00:00 digits
          function GiveDigit(Str:String; Pos:word):byte;
          begin
               try
               GiveDigit:=strtoint(Str[Pos]);
               except
                  on EConvertError do GiveDigit:=10;
               end;
          end;
begin
   if Sticky then
      begin
         TextOut(Canvas,Progress,134,4,[])
      end else
      begin
        if (Progress='') then
           begin
           Paintdigit(11,rect(48,26,57,39));
           Paintdigit(11,rect(61,26,70,39));      // menu
           Paintdigit(11,rect(78,26,87,39));      // menu
           Paintdigit(11,rect(91,26,100,39));      // menu
         end else
         begin
           Paintdigit(GiveDigit(Progress,1),rect(48,26,57,39));
           Paintdigit(GiveDigit(Progress,2),rect(61,26,70,39));      // menu
           Paintdigit(GiveDigit(Progress,4),rect(78,26,87,39));      // menu
           Paintdigit(GiveDigit(Progress,5),rect(91,26,100,39));      // menu
         end;
      end;
end;

procedure TWinampSkin.PaintTitleBarButtons;
var src,dest:TRect;
    i,tbp:byte;
begin
     for i:=0 to 2 do
       begin
       case  TitleBarButtonPressed of
             tbpMenu:tbp:=0;
             tbpMinimize:tbp:=1;
             tbpClose:tbp:=2;
       else
             tbp:=99;
       end;
         if tbp = i then
          src:=rect(i*9,9,(i+1)*9,18)
           else
         src:=rect(i*9,0,(i+1)*9,9);

      case i of
           0:dest:=rect(6,3,15,12);      // menu
           1:dest:=rect(244,3,253,12);   // minimize
           2:dest:=rect(264,3,273,12);   // close
      end;
     Canvas.CopyRect(dest,skTitleBar.Canvas,src);
     end;

     if sticky then
        begin
        if TitleBarButtonPressed = tbpSticky then
          src:=rect(9,27,18,36)
           else
          src:=rect(0,27,9,36);
        end else begin
     if TitleBarButtonPressed = tbpSticky then
          src:=rect(9,18,18,27)
           else
          src:=rect(0,18,9,27);
     end;
     dest:=rect(254,3,263,12);   // sticky
     Canvas.CopyRect(dest,skTitleBar.Canvas,src);

end;

procedure TWinampSkin.PaintVolume;
var src,dest:TRect;
   stufe:byte;
   vol:integer;
begin
     vol:=Volume+1;
       stufe:=trunc(27/(100/vol));
     src:=rect(0,stufe*15,68,((stufe+1)*15)-1);
     dest:=rect(107,57,175, 72);
     Canvas.CopyRect(dest,skVolume.Canvas,src);
     if VolumeFocus then
       src:=rect(0,422,14,433)
     else
       src:=rect(15,422,29,433);
     dest:=rect(107+trunc(54/(100/vol)),59,121+trunc(54/(100/vol)),70);
     Canvas.CopyRect(dest,skVolume.Canvas,src);
end;

procedure TWinampSkin.SetBalance(Value: integer);
begin
     FBalance:=Value;
     PaintBalance;
end;

procedure TWinampSkin.SetChecked(value: TSkinChecked);
begin
     FChecked:=value;
     PaintCheckboxes;
end;



procedure TWinampSkin.TestButtons(x, y: integer);
var i:byte;
begin
     ButtonPressed:=bpNone;
    for i:=0 to 4 do  //  dest:=rect(i*22+18,87,(i+1)*22+19,107);
         if (x>i*23+18) and (x<(i+1)*23+19) and
            (y>87) and (y<105) then
            begin

             case i of
                  0: ButtonPressed:=bpBack;
                  1: ButtonPressed:=bpPlay;
                  2: ButtonPressed:=bpPause;
                  3: ButtonPressed:=bpStop;
                  4: ButtonPressed:=bpForward;
             end;
                MouseDownOver:=moButtons;
            end;
         if InRect(x,y,136,89,158,105) then
            begin
                ButtonPressed:=bpEject;
                MouseDownOver:=moButtons;
            end;

         if InRect(x,y,164,89,211,105) then
            begin
                 ButtonPressed:=bpShuffle;
                 MouseDownOver:=moButtons;
            end;

        if InRect(x,y,210,89,237,104) then
            begin
                 ButtonPressed:=bpRepeat;
                 MouseDownOver:=moButtons;
            end;
         if InRect(x,y,242,58,265,70) then
            begin
                 ButtonPressed:=bpPlaylist;
                 MouseDownOver:=moButtons;
            end;
       if InRect(x,y,219,58,242,70) then
            begin
                 ButtonPressed:=bpEqualizer;
                 MouseDownOver:=moButtons;
            end;
          PaintButtons;
          PaintCheckboxes;
end;

procedure TWinampSkin.TestTitleBarButtons(x, y: integer);
begin
    TitleBarButtonPressed := tbpNone;
    if InRect(x,y,6,3,16,12) then
       TitleBarButtonPressed := tbpMenu;
    if InRect(x,y,244,3,253,12) then
       TitleBarButtonPressed := tbpMinimize;
    if InRect(x,y,264,3,273,12) then
       TitleBarButtonPressed := tbpClose;
    if InRect(x,y,254,3,263,12) then
       TitleBarButtonPressed := tbpSticky;
    if TitleBarButtonPressed > tbpNone then
            MouseDownOver:=moTitleBar;
     PaintTitleBarButtons;
end;

procedure TWinampSkin.TestTitle(x, y: integer);
begin
     if InRect(x,y,109,24,255,36) then
     begin
         MouseDownOver:=moTextScroll;
     ScrollTimer.Enabled:=false;
     MouseDownTitlePos:=TextScrollPos;
     end;
end;


procedure TWinampSkin.TestVolume(x, y: integer);
begin
    if InRect(x,y,107,57,177,72) then
       begin
            VolumeFocus:=true;
            MouseDownOver:=moVolume;
            if not InRect(x,y,107+round(Volume/10*7),57,107+round(Volume/10*7)+14,72) then // if not button pressed
                Volume:=calcvol(x);
            MouseDownVolume:=Volume;
       end;
end;

procedure TWinampSkin.TestBalance(x, y:integer);
begin
    if InRect(x,y,177,57,217,72) then
       begin
            BalanceFocus := true;
            MouseDownOver:=moBalance;
            if not InRect(x,y,177+round(Balance/10*4),57,177+round(Volume/10*4)+14,72) then // if not button pressed
               Balance:=CalcBal(x);
            MouseDownBalance:=Balance;
       end;

end;

procedure TWinampSkin.TestPosBar(x, y: integer);
begin
     if InRect(x,y,18,74,278,84) and not ((Status=ssPlay) or (Status=ssPause)) then
        begin
            PositionBarFocus:=true;
            MouseDownOver:=moPosBar;
             MouseDownPosBar:=x-18;
             if not InRect(x,y,18+round(PositionBar/256*230),74,18+round(PositionBar/256*230)+29,84) then // if not button pressed
               PositionBar:=round((x-18)/208*255)-15;
             PaintPosBar;

        end
end;


procedure TWinampSkin.SetTitle(const Value: string);
begin
  FTitle := Value;
   TextScrollPos:=0;
   if titlelength>30 then ScrollTimer.Enabled := True;
  PaintTitle;
end;


procedure TWinampSkin.PaintTitle;
var text:string;
begin
     if systemtitle='' then
        text:=title
     else
        text:=systemtitle;

     TextBMP.Canvas.Brush.color:=clBlack;
     TextBMP.Canvas.FillRect(rect(0,0,155,10));
     TitleLength:=TextOut(TextBMP.Canvas,Title,0,0,[]);

     Canvas.CopyRect(rect(110,27,265,33),skmain.canvas,rect(110,27,265,33));

    if Length(Text)>31 then
     begin
      if abs(TextScrollPos) >= TitleLength then
         TextScrollPos:=0;
      Canvas.CopyRect(rect(110,27,265,33),textbmp.canvas,rect(TextScrollPos,0,TextScrollPos+155,6));
      if TextScrollPos+155 > TitleLength then // nach links
         Canvas.CopyRect(rect(110+Titlelength-TextScrollPos,27,265,33),textbmp.canvas,rect(0,0,265-(110+TitleLength-TextScrollPos),6));
      if TextScrollPos < 0 then  // nach rechts
          if TextScrollPos < -155 then
                  Canvas.CopyRect(rect(110,27,265,33),textbmp.canvas,rect(titlelength+textscrollpos,0,titlelength+textscrollpos+155,6))
             else
                Canvas.CopyRect(rect(110,27,110-textscrollpos,33),textbmp.canvas,rect(titlelength+textscrollpos,0,titlelength,6));
     end else
      TextOut(Canvas,Text,110,27,[]);
end;

procedure TWinampSkin.PaintStatus;
var x:integer;
begin
   case Status of
        ssNone:x:=27;
        ssPlay:x:=0;
        ssPause:x:=9;
        ssStop:x:=18;
        else
            x:=27;
   end;
   Canvas.CopyRect(rect(24,28,33,37),skPlayPaus.Canvas,rect(x,0,x+9,9));
   if (Status=ssPlay) then
    begin
     if Ready then
        Canvas.CopyRect(rect(24,28,27,37),skPlayPaus.Canvas,rect(36,0,39,9))
     else
        Canvas.CopyRect(rect(24,28,27,37),skPlayPaus.Canvas,rect(39,0,40,9));
     end;
end;

procedure TWinampSkin.SetSticky(const Value: boolean);
begin
  FSticky := Value;
  if FSticky then
     Height:=14
    else
     Height:=116;
   if Assigned (FOnSticky) then
      FOnSticky(self,FSticky);
end;

procedure TWinampSkin.TestStickyButtons(x, y:integer);
begin
     if InRect(x,y,168,3,176,12) then
        if Assigned (FOnBack) then
           FOnBack(self);
     if InRect(x,y,176,3,186,12) then
        if Assigned (FOnPlay) then
           FOnPlay(self);
     if InRect(x,y,186,3,196,12) then
        if Assigned (FOnPause) then
           FOnPause(self);
     if InRect(x,y,196,3,205,12) then
        if Assigned (FOnStop) then
           FOnStop(self);
     if InRect(x,y,205,3,213,12) then
        if Assigned (FOnForward) then
           FOnForward(self);
     if InRect(x,y,215,4,224,12) then
        if Assigned (FOnEject) then
           FOnEject(self);

end;

procedure TWinampSkin.GetCharPos(c: char; var x,y:integer;Mode: TSkinFont);
var b:byte;
begin
     b:=ord(c);
     y:=0;
     x:=142; //default space
     if (b>64) and (b<91) then  // A..Z
       begin
        x:=(b-65)* 5;
       end;
     if b=32 then  // [space]
       begin
        x:=142;
       end;
     if b=34 then  // "
       begin
        x:=131;
       end;
     if b=64 then  // @
       begin
        x:=136;
      end;
     if (b>47) and (b<58) then  // 0..9
        begin
        x:=(b-48)*5; y:=6;
        end;
     if b=40 then // (
        begin
        x:=65; y:=6;
        end;
     if b=41 then // )
        begin
        x:=70; y:=6;
        end;
      if b=45 then // -
        begin
        x:=75; y:=6;
        end;
      if b=39 then // '
        begin
        x:=80; y:=6;
        end;
     if b=33 then // !
        begin
        x:=85; y:=6;
        end;
     if b=95 then // _
        begin
        x:=90; y:=6;
        end;
     if b=58 then // :
        begin
        x:=60; y:=6;
        end;
     if b=42 then // _
        begin
        x:=20; y:=12;
        end;
     if b=46 then // .
        begin
        x:=135; y:=6;
        end;
     if b=37 then // %
        begin
        x:=130; y:=6;
        end;
     if b=43 then // +
        begin
        x:=95; y:=6;
        end;
     if b=92 then // \
        begin
        x:=100; y:=6;
        end;
     if b=47 then // /
        begin
        x:=105; y:=6;
        end;
     if b=64 then // @
        begin
        x:=135; y:=0;
        end;
     if (sfSelected in Mode) then
        y:=y+18;
     if (sfBold in Mode) then
        y:=y+38;
end;

function TWinampSkin.TextOut(Can:TCanvas;s: string; x, y: integer; font: TSkinFont):integer;
var i,
    sy,
    sx:integer;
    src:TRect;
    us:string;
begin
     us:=uppercase(s);
     for i:=1 to length(s) do
         begin
         GetCharPos(us[i],sx,sy,font);
         src:=rect(sx,sy,sx+5,sy+6);
         Can.CopyRect(rect(x+((i-1)*5),y,x+((i)*5),y+6),skText.Canvas,src);
         end;
     TextOut:=length(s)*5;
end;

procedure TWinampSkin.PaintPosBar;
var sel:byte;
begin
     if PositionBarFocus then
        sel:=29 else
        sel:= 0;
     Canvas.CopyRect(rect(18,72,263,82),skPosbar.Canvas,rect(0,0,247,10));
     if (positionbar>0) then
       Canvas.CopyRect(rect(18+trunc(208/(256/positionbar)),72,18+trunc(218/(256/positionbar))+29,82),skPosbar.Canvas,rect(249+sel,0,278+sel,10));
end;

procedure TWinampSkin.SetStatus(const Value: TStatus);
begin
  FStatus := Value;
  PaintStatus;

{  case  Status of   // this work should be do in main program..
        ssStop:  begin
                 leftmeter:=0;
                 rightmeter:=0;
                 setposition(-1,-1);
                 progress:='';
                 frequency:=-1;
                 bitrate:=-1;
                stereomode:=[];
                 end;
        ssPause: begin
                 leftmeter:=0;
                 rightmeter:=0;
                 end;
        else

     end;}
end;

procedure TWinampSkin.SetReady(const Value: boolean);
begin
  FReady := Value;
  PaintStatus;
end;

procedure TWinampSkin.SetBitrate(const Value: integer);
begin
  if Value>999 then
    FBitrate := 999
  else
    FBitrate := Value;
  PaintBitrate;
end;

procedure TWinampSkin.SetFrequency(const Value: integer);
begin
  if Value > 99000 then
     FFrequency := 99000
  else
      FFrequency := Value;
  PaintFrequency;
end;

procedure TWinampSkin.SetStereoMode(const Value: TStereoMode);
begin
  FStereoMode := Value;
  PaintStereoMode;
end;

procedure TWinampSkin.PaintBitrate;
begin
     if Bitrate>-1 then
       TextOut(Canvas,inttostr(bitrate),111,43,[]);
end;

procedure TWinampSkin.PaintFrequency;
begin
     if Frequency>-1 then
       TextOut(Canvas,inttostr(trunc(frequency/1000)),156,43,[]);
end;

procedure TWinampSkin.PaintStereoMode;
var src:TRect;
begin
   if smMono in StereoMode then
      src:=rect(29,0,58,12)
     else
      src:=rect(29,12,58,24);
    Canvas.Copyrect(rect(212,41,241,53),skMonoSter.Canvas,src);

   if smStereo in StereoMode then
      src:=rect(0,0,29,12)
     else
      src:=rect(0,12,29,24);
    Canvas.Copyrect(rect(239,41,268,53),skMonoSter.Canvas,src);

end;


procedure TWinampSkin.SetLeftMeter(const Value: byte);
begin
  FLeftMeter := Value;
  PaintMeter;
end;

procedure TWinampSkin.SetRightMeter(const Value: byte);
begin
  FRightMeter := Value;
  PaintMeter;
end;

procedure TWinampSkin.PaintMeter;
var i:byte;
begin
     Canvas.CopyRect(rect(24+round(LeftMeter/50*77),46,101,50),skMain.Canvas,rect(24+(round(LeftMeter/50*77)),46,101,50));
     Canvas.CopyRect(rect(24+round(RightMeter/50*77),53,101,57),skMain.Canvas,rect(24+(round(RightMeter/50*77)),53,101,57));
      for i:=0 to 77 do
         begin
         if LeftMeter/50*77>i then
            begin
            Canvas.Pen.Color:=VisColor[2+(15-(round(i/77*16)))];
            Canvas.MoveTo(24+i,46);
            Canvas.LineTo(24+i,50);
            end;
         if RightMeter/50*77>i then
            begin
            Canvas.Pen.Color:=VisColor[2+(15-(round(i/77*16)))];
            Canvas.MoveTo(24+i,53);
            Canvas.LineTo(24+i,57);
            end;
         end;
end;

procedure TWinampSkin.TextTimer(Sender: TObject);
begin
     TextScrollPos:=TextScrollPos+5;
     PaintTitle;
end;

{procedure TWinampSkin.SetTextScrollPos(const Value: integer);
begin
  FTextScrollPos := Value;
  PaintTitle;
end;
}
procedure TWinampSkin.SetActive(const Value: boolean);
begin
  FActive := Value;
  Paint;
end;

procedure TWinampSkin.SetVolume(const Value: integer);
begin
   if Value<0 then FVolume:=0
      else begin
      if Value>100 then FVolume:=100
        else
       FVolume := Value;
       end;
  PaintVolume;
end;


procedure TWinampSkin.SetPositionBar(const Value: integer);
begin
    if (Value>256) then
      Fpositionbar:=256
    else
      FPositionBar:=Value;
   PaintPosBar;
end;

procedure TWinampSkin.SetProgress(const Value: string);
begin
  FProgress := Value;
  PaintProgress;
end;

procedure TWinampSkin.SetSystemTitle(const Value: string);
begin
  FSystemTitle := Value;
  PaintTitle;
end;

procedure TWinampSkin.SetTextScrollTimer(const Value: Cardinal);
begin
  If Value < 50 then FTextScrollTimer :=  50
     else
  FTextScrollTimer := Value;

  ScrollTimer.Interval:=FTextScrollTimer;
end;

initialization
  RegisterClass(TWinampSkin);

end.
